<?php
/*********************************************************
* Image Gallery - JOImageGallery.php                     *
* Copyright 2011 by Joseph O'Hara                        *
* All Rights Reserved                                    *
**********************************************************
* Call from an HTML page using the following construct:  *
* <a href="JOImageGallery.php?dir=[location]">Photos</a> *
*                                                        *
* where [location] is the pathname of the picture files  *
* directory.                                             *
*                                                        *
* This program includes a PHP algorithm "PREG_FIND" by   *
* Paul Gregg, Version 2.2 (see below)                    *
*                                                        *
* Program is set to sort pictures alphabetically by      *
* file name. (Sequence is 0-9,A-Z,a-z)                   *
*                                                        *
**********************************************************
* Change the following values in JOImageVars.inc in the  *
* picture directory:                                     *
*     $pgtitle = "Your Page Title here";                 *
*     $divwidth = "Width of full display area";          *
*     $thumbheight = "height of thumbnail picture";      *
*     $stylesheet = "full pathname of stylesheet";       *
*     $bgcolor = "Background color as #RRGGBB";          *
*     $textcolor = "Text color as #RRGGBB";              *
*     $exten = "file extension of pictures";             *
*     $text = "file extension of associated captions";   *
*     $myfontsize = "font size";                         *
*                                                        *
* The defaults can be found in the JOImageVars.inc file  *
* included in the zip file.                              *
*********************************************************/
define('PREG_FIND_RECURSIVE', 1);
define('PREG_FIND_DIRMATCH', 2);
define('PREG_FIND_FULLPATH', 4);
define('PREG_FIND_NEGATE', 8);
define('PREG_FIND_DIRONLY', 16);
define('PREG_FIND_RETURNASSOC', 32);
define('PREG_FIND_SORTDESC', 64);
define('PREG_FIND_SORTKEYS', 128); 
define('PREG_FIND_SORTBASENAME', 256);   # requires PREG_FIND_RETURNASSOC
define('PREG_FIND_SORTMODIFIED', 512);   # requires PREG_FIND_RETURNASSOC
define('PREG_FIND_SORTFILESIZE', 1024);  # requires PREG_FIND_RETURNASSOC
define('PREG_FIND_SORTDISKUSAGE', 2048); # requires PREG_FIND_RETURNASSOC
define('MYSORT', 256);

// PREG_FIND_RECURSIVE   - go into subdirectorys looking for more files
// PREG_FIND_DIRMATCH    - return directorys that match the pattern also
// PREG_FIND_DIRONLY     - return only directorys that match the pattern (no files)
// PREG_FIND_FULLPATH    - search for the pattern in the full path (dir+file)
// PREG_FIND_NEGATE      - return files that don't match the pattern
// PREG_FIND_RETURNASSOC - Instead of just returning a plain array of matches,
//                         return an associative array with file stats
//
function show_pic2 ($key) {
	include "JOImageVars.inc";
	$picturedir = $_GET['dir'];
	$strtdir = getcwd();
	$ch = chdir ($picturedir);
	if ($ch) include "JOImageVars.inc";
	$mydir = getcwd();
	$tmp = chdir ($strtdir);

   $filename = $key;
   $img = @imagecreatefromjpeg($filename);

   if ($img) {
     $img_height = imagesy($img);
     ImageDestroy($img);
   }
   $ht = $thumbheight;
   $mar = 0;
   if ($img_height < $thumbheight) {
      $ht = $img_height;
	  $mar = $thumbheight - $img_height;
   }
	echo "<div style=\"float:left; padding:10px 10px 10px 10px; margin:".$mar."px 0px 0px 0px;\">";
	echo "<a href=\"JOImageDisplay.php?pic=".$filename."&dir=".$picturedir."\">";
	echo "<img src=\"".$filename."\" height=\"".$ht."\" border=\"0\" />";
	echo "</a>";
	$capname = str_replace($exten,$text,$filename);
	$caption = "";
	$fhandle = fopen ($capname, "r");
	$caption = fgets ($fhandle, 80);
	fclose ($fhandle);
	echo "<br />".$caption."\n";
	echo "</div>\n";
}
/*
 * Find files in a directory matching a pattern
 *
 *
 * Paul Gregg <pgregg@pgregg.com>
 * 20 March 2004,  Updated 20 April 2004
 * Updated 18 April 2007 to add the ability to sort the result set
 * Updated 9 June 2007 to prevent multiple calls to sort during recursion
 * Version: 2.2
 * This function is backwards capatible with any code written for a
 * previous version of preg_find()
 *
 * Open Source Code:   If you use this code on your site for public
 * access (i.e. on the Internet) then you must attribute the author and
 * source web site: http://www.pgregg.com/projects/php/preg_find/preg_find.phps
 * Working examples: http://www.pgregg.com/projects/php/preg_find/
 *
 */

// You can also request to have the results sorted based on various criteria
// By default if any sorting is done, it will be sorted in ascending order.
// You can reverse this via use of:
// PREG_FIND_SORTDESC    - Reverse order of sort
// PREG_FILE_SORTKEYS    - Sort on the keyvalues or non-assoc array results
// The following sorts *require* PREG_FIND_RETURNASSOC to be used as they are
// sorting on values stored in the constructed associative array
// PREG_FIND_SORTBASENAME - Sort the results in alphabetical order on filename
// PREG_FIND_SORTMODIFIED - Sort the results in last modified timestamp order
// PREG_FIND_SORTFILESIZE  - Sort the results based on filesize
// PREG_FILE_SORTDISKUSAGE - Sort based on the amount of disk space taken
// to use more than one simply seperate them with a | character



// Search for files matching $pattern in $start_dir.
// if args contains PREG_FIND_RECURSIVE then do a recursive search
// return value is an associative array, the key of which is the path/file
// and the value is the stat of the file.
function preg_find($pattern, $start_dir='.', $args=NULL) {

  static $depth = -1;
  ++$depth;

  $files_matched = array();

  $fh = opendir($start_dir);

  while (($file = readdir($fh)) !== false) {
    if (strcmp($file, '.')==0 || strcmp($file, '..')==0) continue;
    $filepath = $start_dir . '/' . $file;
    if (preg_match($pattern,
					$filepath)) {
//                   ($args & PREG_FIND_FULLPATH) ? $filepath : $file)) {
      $doadd =    is_file($filepath);
      if ($doadd) {
          array_push($files_matched, $filepath);
      }
    }
  }

  closedir($fh); 

  // Before returning check if we need to sort the results.
  if (($depth==0) && ($args & (PREG_FIND_SORTKEYS|PREG_FIND_SORTBASENAME|PREG_FIND_SORTMODIFIED|PREG_FIND_SORTFILESIZE|PREG_FIND_SORTDISKUSAGE)) ) {
    $order = ($args & PREG_FIND_SORTDESC) ? 1 : -1;
    $sortby = '';
    if ($args & PREG_FIND_RETURNASSOC) {
      if ($args & PREG_FIND_SORTMODIFIED)  $sortby = "['stat']['mtime']";
      if ($args & PREG_FIND_SORTBASENAME)  $sortby = "['basename']";
      if ($args & PREG_FIND_SORTFILESIZE)  $sortby = "['stat']['size']";
      if ($args & PREG_FIND_SORTDISKUSAGE) $sortby = "['du']";
    }
    $filesort = create_function('$a,$b', "\$a1=\$a$sortby;\$b1=\$b$sortby; if (\$a1==\$b1) return 0; else return (\$a1<\$b1) ? $order : 0- $order;");
    uasort($files_matched, $filesort);
  }
  --$depth;
  return $files_matched;

}
session_start();
session_cache_limiter();
error_reporting(0);
include "JOImageVars.inc";
$picturedir = $_GET['dir'];
$strtdir = getcwd();
$ch = chdir ($picturedir);
if ($ch) include "JOImageVars.inc";
$mydir = getcwd();
$tmp = chdir ($strtdir);
$myhost = $_SERVER['HTTP_HOST'];
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<?php echo "<title>".$pgtitle."</title>\n"; ?>
<?php if ($stylesheet) echo $stylesheet; ?>
</head>

<?php echo "<body style=\"background-color:".$bgcolor."; font-size:".$myfontsize."; color:".$textcolor.";\">\n"; ?>
<h3 style="text-align:center"><a href="javascript:history.back();"><strong>&lt;&lt;&lt;&lt; BACK</strong></a><br /><br />Click on a picture to see it full-size.</h3>
<div style="width:<?php echo $divwidth; ?>px; margin:0px 46px 0px 22px;">
<center>
<?php
$pattern = "/";
$pattern .= $exten;
$pattern .= "\b/i";
$args = MYSORT;
(array)$pictures = preg_find($pattern, $picturedir, $args);
array_walk ($pictures, "show_pic2", $picturedir);
?>
</center>
</div>
</body>
</html>